global mov_all_bytes_asm
global nop_all_bytes_asm
global nop_1x3_all_bytes_asm
global nop_1x9_all_bytes_asm
global inc_all_bytes_asm
global dec_all_bytes_asm
global align64_loop
global align1_loop
global align15_loop
global align31_loop
global align63_loop
global align75_loop
global align90_loop
global align112_loop
global rat_add
global rat_mov_add
global read_1
global read_2
global read_3
global read_4
global read_8
global write_1
global write_2
global write_3
global write_4
global write_8
global read_1x2_low
global read_1x2_high
global read_2x2
global read_4x2
global read_8x2

mov_all_bytes_asm:
	xor rax, rax

	.loop:
		mov BYTE [rdi + rax * 1], al
		inc rax
		cmp rsi, rax
		jne .loop

	ret

nop_all_bytes_asm:
	xor rax, rax

	.loop:
		db 0x0f, 0x1f, 0x00
		inc rax
		cmp rdi, rax
		jne .loop

	ret

nop_1x3_all_bytes_asm:
	xor rax, rax

	.loop:
		nop
		nop
		nop
		inc rax
		cmp rdi, rax
		jne .loop

	ret

nop_1x9_all_bytes_asm:
	xor rax, rax

	.loop:
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		inc rax
		cmp rdi, rax
		jne .loop

	ret

inc_all_bytes_asm:
	xor rax, rax

	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

dec_all_bytes_asm:
	.loop:
		dec rdi
		jnz .loop

	ret

align64_loop:
	xor rax, rax

	align 64
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align1_loop:
	xor rax, rax

	align 64
	nop
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align15_loop:
	xor rax, rax

	align 64
	%rep 15
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align31_loop:
	xor rax, rax

	align 64
	%rep 31
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align63_loop:
	xor rax, rax

	align 64
	%rep 63
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align75_loop:
	xor rax, rax

	align 64
	%rep 75
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align90_loop:
	xor rax, rax

	align 64
	%rep 90
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align112_loop:
	xor rax, rax

	align 64
	%rep 112
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

rat_add:
	mov rax, rdi

	.loop:
		add rcx, 1
		add rcx, 1
		dec rax
		jnz .loop
	ret

rat_mov_add:
	mov rax, rdi

	.loop:
		mov rcx, rax
		add rcx, 1
		mov rcx, rax
		add rcx, 1
		dec rax
		jnz .loop
	ret

read_1:
	align 64
	.loop:
		mov rax, [rdi]
		sub rsi, 1
		jnle .loop

	ret

read_2:
	align 64
	.loop:
		%rep 2
		mov rax, [rdi]
		%endrep
		sub rsi, 2
		jnle .loop

	ret

read_3:
	align 64
	.loop:
		%rep 3
		mov rax, [rdi]
		%endrep
		sub rsi, 3
		jnle .loop

	ret

read_4:
	align 64
	.loop:
		%rep 4
		mov rax, [rdi]
		%endrep
		sub rsi, 4
		jnle .loop

	ret

read_8:
	align 64
	.loop:
		%rep 8
		mov rax, [rdi]
		%endrep
		sub rsi, 8
		jnle .loop

	ret

write_1:
	align 64
	.loop:
		mov QWORD [rdi], 0
		sub rsi, 1
		jnle .loop

	ret

write_2:
	align 64
	.loop:
		%rep 2
		mov QWORD [rdi], 0
		%endrep
		sub rsi, 2
		jnle .loop

	ret

write_3:
	align 64
	.loop:
		%rep 3
		mov QWORD [rdi], 0
		%endrep
		sub rsi, 3
		jnle .loop

	ret

write_4:
	align 64
	.loop:
		%rep 4
		mov QWORD [rdi], 0
		%endrep
		sub rsi, 4
		jnle .loop

	ret

write_8:
	align 64
	.loop:
		%rep 8
		mov QWORD [rdi], 0
		%endrep
		sub rsi, 8
		jnle .loop

	ret

read_1x2_low:
	align 64
	.loop:
		%rep 2
		mov al, [rdi]
		%endrep
		sub rsi, 2
		jnle .loop

	ret

read_1x2_high:
	align 64
	.loop:
		%rep 2
		mov ah, [rdi]
		%endrep
		sub rsi, 2
		jnle .loop

	ret

read_2x2:
	align 64
	.loop:
		%rep 2
		mov ax, [rdi]
		%endrep
		sub rsi, 2
		jnle .loop

	ret

read_4x2:
	align 64
	.loop:
		%rep 2
		mov eax, [rdi]
		%endrep
		sub rsi, 2
		jnle .loop

	ret

read_8x2:
	align 64
	.loop:
		%rep 2
		mov rax, [rdi]
		%endrep
		sub rsi, 2
		jnle .loop

	ret
